<?php

/*

Plugin Name: MakeMyText

Description: Plugin officiel de MakeMyText.com.

Version: 1.2.0

Author: MakeMyText

Author URI: https://www.makemytext.com


*/



add_action('admin_menu', 'my_admin_menu_mmt');



function my_admin_menu_mmt() {
    add_menu_page(
        "MakeMyText",
        "MakeMyText",
        'manage_options',
        'makemytext',
        'my_admin_page_contents_mmt',
        'https://www.makemytext.com/wp-content/uploads/fbrfg/favicon-16x16.png',
        3
    );
}






function my_admin_page_contents_mmt() {
    ?>
    <style>
        #submit{
            padding: 10px;
            cursor: pointer;
            background-color: black;
            text-align: center;
            color: white;
            font-weight: bold;
            width: 250px;
            margin-top:20px;
            border: 0px;
            border-radius: 5px;
        }
        #mmt-form {
            display: flex;
            flex-direction: column;
            background-color: white;
            padding: 20px;
            max-width: 400px;
            border-radius: 10px;
            padding-bottom: 40px;
            box-shadow: 0 0 4px silver;
        }
        #mmt-form select {
            max-width: 250px;
        }
    </style>
    <h1>Publiez vos articles MakeMyText</h1>
    <hr>
    




    <?php
    // Vérifier que les images sont bien uploadées sans erreur
    // Vérifier que le post est bien publié sans erreur



    // Récupérer le fichier transmis par le formulaire en POST et les autres données
    $fichier = "";
    if(isset($_POST['submit']) && $_FILES['fichier']['error'] === UPLOAD_ERR_OK && isset($_POST['categorie']) && isset($_POST['auteur'])) {
        $fichier = file_get_contents($_FILES['fichier']['tmp_name']);
        $categorie = $_POST['categorie'];
        $auteur = $_POST['auteur'];
        $publier_directement = $_POST['publier'];
        if($publier_directement == "publier") {
            $publier_directement = "publish";
        } else {
            $publier_directement = "draft";
        }



        // Vérifications sur le fichier reçu
        if(!(strlen($fichier) > 0) || !str_contains($fichier, "Title") || !str_contains($fichier, "Permalien") || count(explode("\t", explode("\n", $fichier)[0])) != 4) {
            echo "<p>Merci de fournir un fichier .tsv valide.</p>";
            exit();
        }

    

        // Dans le fichier .tsv, récupérer pour chaque texte : le title, le permalien, l'image principale, le HTML compressé
        // Récupérer l'id de l'image à la une
        // Récupérer toutes les images dans le HTML compressé
        // Les uploader sur WP
        // Ensuite récupérer l'URL de chaque image et l'insérer à la bonne place dans le contenu
        // Publier sur le WordPress du client en brouillon


        // Récupère les url des images dans du HTML
        function recuperer_url_images_html($html) {
            $images = [];
            $nom_fichier = [];
            $doc = new DOMDocument();
            @$doc->loadHTML($html);
            $tags = $doc->getElementsByTagName('img');
            foreach ($tags as $tag) {
                $images[] = $tag->getAttribute('src');
                $nom_fichier[] = normalizer_normalize(str_replace(" ", "-", $tag->getAttribute('alt')));
            }
            if(count($images) != count($nom_fichier)) {
                echo "<p>Votre fichier .tsv n'a pas autant d'images que d'attributs alt. Merci de contacter le support MakeMyText.</p>";
                exit();
            }
            return [$images, $nom_fichier];
        }

        // Upload une image dans la médiathèque WordPress
        function uploader_image_sur_wp($url_image) {
            $file = array();
            $file['tmp_name'] = download_url($url_image[0]);
            $file['name'] = $url_image[1] . image_type_to_extension(getimagesize($file['tmp_name'])[2]);
            $attachmentId = media_handle_sideload($file);
            $image_url = wp_get_attachment_url($attachmentId);
            return [$attachmentId, $image_url];
        }

        // Prend en entrée un tableau des nouvelles url d'image
        // Pour chaque url i, modifie le src de l'image i dans le HTML
        function modifier_url_images_html($images, $html) {
            $doc = new DOMDocument();
            @$doc->loadHTML($html);
            $tags = $doc->getElementsByTagName('img');
            $i = 0;
            foreach ($tags as $tag) {
                $tag->setAttribute('src', $images[$i]);
                $i++;
            }
            return $doc->saveHTML();
        }

        // Publie un article sur WordPress
        function publieSurWordPress($image_a_la_une, $h1, $html, $permalien, $categorie, $auteur, $publier_directement) {
            $post = array(
                'post_title'    => $h1,
                'post_content'  => $html,
                'post_status'   => $publier_directement,
                'post_type'     => 'post',
                'post_name'     => $permalien,
                'post_category' => array($categorie),
                'post_author'   => $auteur
            );
            $id_post = wp_insert_post($post);
            set_post_thumbnail($id_post, $image_a_la_une);
        }


        // Traitements sur le html
        function traitementsHTML($html) {
            $texte = str_replace("&acirc;&#128;&macr;", " ", $html);
            $texte = str_replace("<strong><h2>", "<h2>", $texte);
            $texte = str_replace("</h2></strong>", "</h2>", $texte);
            return $texte;
        }


        // Fonction principale
        function mmt($texte, $categorie, $auteur, $publier_directement) {
            $image_a_la_une = $texte[2];
            $id_image_a_la_une = uploader_image_sur_wp([$image_a_la_une, normalizer_normalize(str_replace(" ", "-", $texte[1]))])[0];
            $images_dans_html = recuperer_url_images_html($texte[3]);
            $tableau_nouvelles_url_images = [];
            for($i=0; $i < count($images_dans_html[0]); $i++) {
                $image_url = uploader_image_sur_wp([$images_dans_html[0][$i], $images_dans_html[1][$i]])[1];
                $tableau_nouvelles_url_images[] = $image_url;
            }
            $html = modifier_url_images_html($tableau_nouvelles_url_images, $texte[3]);
            $html = traitementsHTML($html);
            publieSurWordPress($id_image_a_la_une, $texte[0], $html, $texte[1], $categorie, $auteur, $publier_directement);
        }



        // MAIN

        // Lire le fichier.tsv et récupérer le contenu
        $lignes = explode("\n", $fichier);
        $textes = array();
        $i = 0;
        foreach($lignes as $ligne) {
            if($i != 0) {
                $textes[] = explode("\t", $ligne);
            } else {
                $i = 1;
            }
        }
        foreach($textes as $texte) {
            mmt($texte, $categorie, $auteur, $publier_directement);
        }
        echo '<p>Tous les articles ont été publiés !</p>';
        echo '<img style="width:40px;" src="https://www.makemytext.com/wp-content/uploads/2022/08/check-2.gif" />';
    } else {
    ?>


    <form action="" method="post" enctype="multipart/form-data" id="mmt-form">
        <p>Transférez ici le fichier .tsv présent dans le .zip de votre pack :</p>
        <input type="file" name="fichier" required>
        <p>Catégorie :</p>
        <select name="categorie" id="categories">
        <?php
        $categories = get_terms("category", array("hide_empty" => false));
        foreach($categories as $category) {
            echo '<option value="' . $category->term_id . '">' . $category->name . '</option>';
        }
        ?>
        </select>
        <p>Auteur :</p>
        <select name="auteur" id="auteurs">
        <?php
        $auteurs = get_users();
        foreach($auteurs as $auteur) {
            echo '<option value="' . $auteur->ID . '">' . $auteur->display_name . '</option>';
        }
        ?>
        </select>
        <p>
            <input type="checkbox" name="publier" id="publier" value="publier">
            <label for="publier">Publier directement sans mettre en brouillon</label>
        </p>
        <input id="submit" type="submit" name="submit" value="PUBLIER">
    </form>
    <div id="resultat"></div>


    <script type="text/javascript">
        jQuery("document").ready(function() {
            jQuery("#mmt-form").submit(function() {
                jQuery("#mmt-form").hide();
                jQuery("#resultat").html('<p>Publication en cours... La publication peut prendre quelques minutes. Merci de patienter.</p><img style="width:80px;" src="https://www.makemytext.com/wp-content/uploads/2022/08/loading.gif" />');
            });
        });
    </script>


    <?php
    }
}
